﻿<%@ WebHandler Language="C#" Class="ApiHandler" %>

using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Ext.Direct;

public class ApiHandler : IHttpHandler
{
    private const string DirectHandlerContentType = "text/javascript";

    public void ProcessRequest(HttpContext context)
    {
        context.Response.ContentType = DirectHandlerContentType;

        DirectProviderCache cache = DirectProviderCache.GetInstance();
        DirectProvider provider;
        //After being configured, the provider should be cached.
        provider = new DirectProvider("Ext.app.REMOTING_API", "DirectHandler.ashx");
        provider.Configure(new object[] { new App_Code.UserService() });
        cache["Ext.app.REMOTING_API"] = provider;

        context.Response.Write(provider.ToString());
    }

    public bool IsReusable
    {
        get
        {
            return false;
        }
    }
}
