﻿<%@ Page Language="C#" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<script runat="server">

</script>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title></title>
</head>
<body>
    <form id="form1" runat="server">
    <div>
        <asp:GridView ID="GridView1" runat="server" AutoGenerateColumns="False" 
            DataKeyNames="UserName" DataSourceID="ObjectDataSource1">
            <Columns>
                <asp:BoundField DataField="UserName" HeaderText="UserName" ReadOnly="True" 
                    SortExpression="UserName" />
                <asp:BoundField DataField="FirstName" HeaderText="FirstName" 
                    SortExpression="FirstName" />
                <asp:BoundField DataField="LastName" HeaderText="LastName" 
                    SortExpression="LastName" />
                <asp:TemplateField HeaderText="UserImageUrl" SortExpression="UserImageUrl">
                    <ItemTemplate>
                        <asp:Image runat="server" Width="60" Height="60" ImageUrl='<%# Bind("UserImageUrl") %>' ID="IMG1" />
                    </ItemTemplate>
                    <EditItemTemplate>
                        <asp:TextBox ID="TextBox1" runat="server" Text='<%# Bind("UserImageUrl") %>'></asp:TextBox>
                    </EditItemTemplate>
                </asp:TemplateField>
            </Columns>
        </asp:GridView>
        
        <asp:ObjectDataSource ID="ObjectDataSource1" runat="server" 
            DeleteMethod="Delete" InsertMethod="Insert" 
            OldValuesParameterFormatString="original_{0}" SelectMethod="GetMembers" 
            TypeName="MembershipUtilities.MembershipUserAndProfileODS" 
            UpdateMethod="Update">
            <DeleteParameters>
                <asp:Parameter Name="UserName" Type="String" />
            </DeleteParameters>
            <UpdateParameters>
                <asp:Parameter Name="userName" Type="String" />
                <asp:Parameter Name="email" Type="String" />
                <asp:Parameter Name="isLockedOut" Type="Boolean" />
                <asp:Parameter Name="isApproved" Type="Boolean" />
                <asp:Parameter Name="comment" Type="String" />
                <asp:Parameter Name="lastActivityDate" Type="DateTime" />
                <asp:Parameter Name="lastLoginDate" Type="DateTime" />
                <asp:Parameter Name="firstName" Type="String" />
                <asp:Parameter Name="lastName" Type="String" />
                <asp:Parameter Name="addressLine" Type="String" />
                <asp:Parameter Name="city" Type="String" />
                <asp:Parameter Name="state" Type="String" />
                <asp:Parameter Name="zipCode" Type="String" />
                <asp:Parameter Name="userImageUrl" Type="String" />
            </UpdateParameters>
            <SelectParameters>
                <asp:Parameter Name="sortData" Type="String" />
            </SelectParameters>
            <InsertParameters>
                <asp:Parameter Name="userName" Type="String" />
                <asp:Parameter Name="isApproved" Type="Boolean" />
                <asp:Parameter Name="comment" Type="String" />
                <asp:Parameter Name="lastLockoutDate" Type="DateTime" />
                <asp:Parameter Name="creationDate" Type="DateTime" />
                <asp:Parameter Name="email" Type="String" />
                <asp:Parameter Name="lastActivityDate" Type="DateTime" />
                <asp:Parameter Name="providerName" Type="String" />
                <asp:Parameter Name="isLockedOut" Type="Boolean" />
                <asp:Parameter Name="lastLoginDate" Type="DateTime" />
                <asp:Parameter Name="isOnline" Type="Boolean" />
                <asp:Parameter Name="passwordQuestion" Type="String" />
                <asp:Parameter Name="lastPasswordChangedDate" Type="DateTime" />
                <asp:Parameter Name="password" Type="String" />
                <asp:Parameter Name="passwordAnswer" Type="String" />
                <asp:Parameter Name="firstName" Type="String" />
                <asp:Parameter Name="lastName" Type="String" />
                <asp:Parameter Name="addressLine" Type="String" />
                <asp:Parameter Name="city" Type="String" />
                <asp:Parameter Name="state" Type="String" />
                <asp:Parameter Name="zipCode" Type="String" />
                <asp:Parameter Name="userImageUrl" Type="String" />
            </InsertParameters>
        </asp:ObjectDataSource>
    </div>
    </form>
</body>
</html>
