﻿<%@ WebHandler Language="C#" Class="Save" %>

using System;
using System.Collections.Generic;
using System.Web;
using App_Code;

public class Save : IHttpHandler {
    
    public void ProcessRequest (HttpContext context) {

        string rows = context.Request["rows"];
        if (rows.StartsWith("{"))
        {
            rows = "[" + rows + "]";
        }
        var result = rows.FromJson<List<App_Code.UserResult>>();
        var userManager = new UserManager();
        userManager.Update(ref result);

        var o = new
        {
            total = 100,
            success = true,
            rows = result
        };
        string retString = o.ToJson();
        HttpContext.Current.Response.Write(retString);
    }
 
    public bool IsReusable {
        get {
            return false;
        }
    }

}