<?
$step = isset($_REQUEST['step']) ? $_REQUEST['step'] : 1;
?>
<html>
<head>
    <!-- Standard includes -->
    <link rel="stylesheet" type="text/css" href="../resources/css/ext-all.css"/>
    <script type="text/javascript" src="../adapter/ext/ext-base.js"></script>
    <script type="text/javascript" src="../ext-all.js"></script>

    <!-- Application includes -->
    <link rel="stylesheet" type="text/css" href="steps.css"/>
    <script type="text/javascript" src="steps.js"></script>
    <script type="text/javascript" src="step<?=$step?>.js"></script>
    
    <script>
        Ext.BLANK_IMAGE_URL = '../resources/images/default/s.gif';
    </script>
    
    <style>
	    p {
	        padding:5px;
	        border:1px solid transparent;
	    }
	    .p-hover {
	        border:1px solid #BDD3EF;
	        background:#eee;
	        cursor: pointer;
	    }
	    .negative {
	        background: #FF3F3F;
	    }
	    .negative .x-grid3-cell-inner {
	        color: white;
	        font-weight: bold;
	    }
	    .positive {
	        background: #9EFF7F;
	    }
	    .x-grid3-row-selected {
	        background: #DFE8F6 !important;
	    }
	</style>
</head>
<body>
    <span id="step" class="<?=$step?>"></span>
    
    <div style="display:none;">
        <div id="content2" class="content">
            <p>This is a basic panel with text. Here is something really long.</p>
            <p>Here is another paragraph.</p>
            <p>And another one.</p>
            <p><b>Hints:</b></p>
            <ul>
                <li>Try loading the page content from markup</li>
                <li>Use delegated click handling</li>
                <li>Look at Ext.Element for an easy way to handle the mouseover effect</li>
            </ul>
        </div>
    </div>
</body>
</html>
