Ext.ns('App','App.win');
App.win.CustomWindow = Ext.extend(Ext.Window, {
	modal: true,
	loadingTxt: 'Loading...',
	initComponent : function() {
		Ext.applyIf(this, {
			width: 300,
			height: 400
		});
		this.items = [{},{}];
		App.win.CustomWindow.superclass.initComponent.call(this);
	},
	onRender: function(ct, pos) {
		//App.win.CustomWindow.superclass.onRender.call(this, ct, pos);
		 App.win.CustomWindow.superclass.onRender.apply(this, arguments);
		 
		 
		 /// 
	},
	newMethod: function() {},
	overridenMethod: function() {}
});


Ext.override(Ext.Window, {
   newMethod : function() {},
   request : function() {}
});


Ext.apply(Ext.Ajax, {
    request : function(o){
        if(this.fireEvent("beforerequest", this, o) !== false){
            var p = o.params;

            if(typeof p == "function"){
                p = p.call(o.scope||window, o);
            }
            if(typeof p == "object"){
                p = Ext.urlEncode(p);
            }
            if(this.extraParams){
                var extras = Ext.urlEncode(this.extraParams);
                p = p ? (p + '&' + extras) : extras;
            }

            var url = o.url || this.url;
            if(typeof url == 'function'){
                url = url.call(o.scope||window, o);
            }

            if(o.form){
                var form = Ext.getDom(o.form);
                url = url || form.action;

                var enctype = form.getAttribute("enctype");
                if(o.isUpload || (enctype && enctype.toLowerCase() == 'multipart/form-data')){
                    return this.doFormUpload(o, p, url);
                }
                var f = Ext.lib.Ajax.serializeForm(form);
                p = p ? (p + '&' + f) : f;
            }

            var hs = o.headers;
            if(this.defaultHeaders){
                hs = Ext.apply(hs || {}, this.defaultHeaders);
                if(!o.headers){
                    o.headers = hs;
                }
            }

            var cb = {
                success: this.handleResponse,
                failure: this.handleFailure,
                scope: this,
                argument: {options: o},
                timeout : o.timeout || this.timeout
            };

            var method = o.method||this.method||((p || o.xmlData || o.jsonData) ? "POST" : "GET");

            if(method == 'GET' && (this.disableCaching && o.disableCaching !== false) || o.disableCaching === true){
                url += (url.indexOf('?') != -1 ? '&' : '?') + '_dc=' + (new Date().getTime());
            }

            if(typeof o.autoAbort == 'boolean'){ // options gets top priority
                if(o.autoAbort){
                    this.abort();
                }
            }else if(this.autoAbort !== false){
                this.abort();
            }
            if((method == 'GET' || o.xmlData || o.jsonData) && p){
                url += (url.indexOf('?') != -1 ? '&' : '?') + p;
                p = '';
            }
            this.transId = Ext.lib.Ajax.request(method, url, cb, p, o);
            return this.transId;
        }else{
            Ext.callback(o.callback, o.scope, [o, null, null]);
            return null;
        }
    }});

	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
Ext.DomHelper.append(document.body, {
    id: 'my-div',
    cn: [{
    	tag: 'a', 
    	href: 'http://www.yahoo.com/', 
    	html: 'My Link', 
    	target: '_blank'
    }]
});	
	
Ext.DomHelper.append(document.body, {
    id: 'my-div',
    html: '<a href="http://www.yahoo.com/" target="_blank">My Link</a>'
});	
	
	
	
	
myFunction = function(el) {
	el = Ext.get(el);
	
};


Ext.fly('colors').on('click', function(e,t){
        // handle only primary colors

}, this, {delegate: '.primary'});



Ext.fly('colors').on('click', function(e,t){
    var t = e.getTarget('.primary');
    if(t){
        // handle only primary colors
    }
})



// CustomWIndow.js
Ext.namespace('NCEES');
NCEES.CustomWindow = Ext.extend(Ext.Window, {
	usernameLabel: 'Username',
	passwordLabel: 'Password',
	initComponent : function() {
		Ext.apply(this, {
			width: 400,
			height: 300,
			modal: true,
			layout: 'form'
		});	
		this.items = [{
			xtype: 'textfield',
			fieldLabel: this.usernameLabel
		},{
			xtype: 'textfield',
			inputType: 'password',
			fieldLabel: this.passwordLabel
		}];
		NCEES.CustomWindow.superclass.initComponent.call(this);
	},
	newMethod: function() {},
	overridenMethod: function() {}
});
Ext.reg('customwindow', NCEES.CustomWindow);




// sample locale file
if (NCEES.CustomWindow) {
	Ext.apply(NCEES.CustomWindow.prototype, {
		usernameLabel: '',
		passwordLabel: ''
	});
}

















var foo = function(){
	var myString = 'something';
};













drinks: ['coffee','water','redbull']




var tpl = new Ext.XTemplate(
	'<tpl for=".">',
		'<div>sajkfjasf</div>',
        '<div class="thumb-wrap" id="{name}">',
	    '<div class="thumb"><img src="{url}" title="{name}"></div>',
	    '<span class="x-editable">{shortName}</span></div>',
    '</tpl>',
    '<div class="x-clear"></div>'
);






var myFn = function(point) {
	var point = point || {};
	var defaults = {x: 0, y: 0};
	Ext.applyIf(point, defaults);	
	
};





Ext.namespace('App');
App.CustomWindow = Ext.extend(Ext.Window, {
	initComponent : function() {
		App.CustomWindow.superclass.initComponent.call(this);
	},
	newMethod: function() {},
	overridenMethod: function() {}
});
Ext.reg('customwindow', App.CustomWindow);


